<template>
  <div>
    <v-dialog
      ref="dialogStart"
      v-model="datepickerModal"
      persistent
      width="290px"
      :return-value.sync="dateInput"
      :allowed-dates="allowedDates"
    >
      <template v-slot:activator="{ on }">
        <v-text-field
          v-model="dateFormatted"
          :label="label"
          append-icon="event"
          readonly
          :rules="rules"
          hide-details
          outlined
          dense
          clearable
          v-on="on"
        ></v-text-field>
      </template>
      <v-date-picker v-model="dateInput" :allowed-dates="allowedDates" scrollable>
        <v-spacer></v-spacer>
        <v-btn text color="primary" @click="datepickerModal = false">Cancel</v-btn>
        <v-btn text color="primary" @click="$refs.dialogStart.save(dateInput)">OK</v-btn>
      </v-date-picker>
    </v-dialog>
  </div>
</template>
<script>
export default {
  props: {
    value: {
      type: String,
      default: ''
    },
    rules: {
      type: Array,
      default: undefined
    },
    readonly: {
      type: String,
      default: undefined
    },
    label: {
      type: String,
      default: 'Date Picker'
    },
    allowedDate: {
      type: String,
      default: ''
    },
    allowedRule: {
      type: String,
      default: ''
    }
  },
  data() {
    return {
      datepickerModal: false,
      dateInput: this.value
    }
  },
  computed: {
    dateFormatted: {
      get() {
        return this.formatDate(this.dateInput)
      },
      set(value) {
        this.dateInput = value
      }
    }
  },
  watch: {
    dateInput() {
      this.handleInput()
    }
  },
  methods: {
    allowedDates(e) {
      if (this.allowedDate && this.allowedRule) {
        if (this.allowedRule === '>') {
          return e > this.allowedDate
        } else if (this.allowedRule === '<') {
          return e < this.allowedDate
        } else if (this.allowedRule === '>=') {
          return e >= this.allowedDate
        } else if (this.allowedRule === '<=') {
          return e <= this.allowedDate
        } else return true
      } else return true
    },
    handleInput(e) {
      // eslint-disable-next-line no-debugger
      this.$emit('input', this.dateInput ? this.dateInput : '')
    },
    formatDate(date) {
      if (!date) return null
      const [year, month, day] = date.split('-')
      return `${day}-${month}-${year}`
      // return new Date(date).toLocaleString()
    }
  }
}
</script>
